﻿local ESOIta = {}
ESOIta.Flags = { "en", "it" }

function ESOIta_Change(lang)
	zo_callLater(function()
		SetCVar("language.2", lang)
		ReloadUI()
	end, 500)
end

function ESOIta:RefreshUI()
	local flagControl
	local count = 0
	local flagTexture
	for _, flagCode in pairs(ESOIta.Flags) do
		flagTexture = "ESOIta/flags/"..flagCode..".dds"
		flagControl = GetControl("ESOIta_FlagControl_"..tostring(flagCode))
		if flagControl == nil then
			flagControl = CreateControlFromVirtual("ESOIta_FlagControl_", ESOItaUI, "ESOIta_FlagControl", tostring(flagCode))
			GetControl("ESOIta_FlagControl_"..flagCode.."Texture"):SetTexture(flagTexture)
			if ESOIta:GetLanguage() ~= flagCode then
				flagControl:SetAlpha(0.3)
				if flagControl:GetHandler("OnMouseDown") == nil then flagControl:SetHandler("OnMouseDown", function() ESOIta_Change(flagCode) end) end
			end
		end
		flagControl:ClearAnchors()
		flagControl:SetAnchor(LEFT, ESOItaUI, LEFT, 14 +count*34, 0)
		count = count + 1
	end
	ESOItaUI:SetDimensions(25 +count*34, 50)
	ESOItaUI:SetMouseEnabled(true)
end

function ESOIta:GetLanguage()
	local lang = GetCVar("language.2")
	
	if(lang == "it") then return lang end
	return "en"
end

function ESOIta:OnInit(eventCode, addOnName)
	if (addOnName):find("^ZO_") then return end
	EVENT_MANAGER:UnregisterForEvent("ESOIta_OnAddOnLoaded", EVENT_ADD_ON_LOADED)

	for _, flagCode in pairs(ESOIta.Flags) do
		ZO_CreateStringId("SI_BINDING_NAME_"..string.upper(flagCode), string.upper(flagCode))
	end

	ESOIta:RefreshUI()
	
	if ESOIta:GetLanguage() == "it" then
		ESOIta_init()
	end
	
	function ZO_GameMenu_OnShow(control)
		if control.OnShow then
			control.OnShow(control.gameMenu)
			ESOItaUI:SetHidden(hidden)
		end
	end
	
	function ZO_GameMenu_OnHide(control)
		if control.OnHide then
			control.OnHide(control.gameMenu)
			ESOItaUI:SetHidden(not hidden)
		end
	end
end

function ESOIta:SCTFix()
	if ESOIta:GetLanguage() == "it" then
		ESOIta_init()
	end
end

EVENT_MANAGER:RegisterForEvent("ESOIta_OnAddOnLoaded", EVENT_ADD_ON_LOADED, function(_event, _name) ESOIta:OnInit(_event, _name) end)
EVENT_MANAGER:RegisterForEvent("ESOIta_SCTFix", EVENT_PLAYER_ACTIVATED, function(...) ESOIta:SCTFix() end)

function ESOIta_init() 

	function Compass:SetCardinalDirections(font)
		ZO_Compass:GetNamedChild("Container"):SetCardinalDirection("C", font, CARDINAL_DIRECTION_NORTH)
		ZO_Compass:GetNamedChild("Container"):SetCardinalDirection(GetString(SI_COMPASS_EAST_ABBREVIATION), font, CARDINAL_DIRECTION_EAST)
		ZO_Compass:GetNamedChild("Container"):SetCardinalDirection(GetString(SI_COMPASS_WEST_ABBREVIATION), font, CARDINAL_DIRECTION_WEST)
		ZO_Compass:GetNamedChild("Container"):SetCardinalDirection(GetString(SI_COMPASS_SOUTH_ABBREVIATION), font, CARDINAL_DIRECTION_SOUTH)
	end

	if IsInGamepadPreferredMode() then
		Compass:SetCardinalDirections("ZoFontGamepadBold34")
	else
		Compass:SetCardinalDirections("ZoFontHeader4")
	end

	ZO_TOOLTIP_STYLES["tooltip"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_TOOLTIP_STYLES["bodySection"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_TOOLTIP_STYLES["bodyHeader"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_TOOLTIP_STYLES["itemTagsSection"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_TOOLTIP_STYLES["bagCountSection"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_TOOLTIP_STYLES["stableGamepadTooltip"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_TOOLTIP_STYLES["abilityUpgradeSection"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_TOOLTIP_STYLES["worldMapTooltip"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_TOOLTIP_STYLES["mapTitle"]["fontFace"] = "ESOIta/fonts/ftn87.otf"
	ZO_TOOLTIP_STYLES["mapQuestTitle"]["fontFace"] = "ESOIta/fonts/ftn87.otf"
	ZO_TOOLTIP_STYLES["mapLocationTooltipContentHeader"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_TOOLTIP_STYLES["mapLocationTooltipWayshrineHeader"]["fontFace"] = "ESOIta/fonts/ftn87.otf"
	ZO_TOOLTIP_STYLES["mapKeepUnderAttack"]["fontFace"] = "ESOIta/fonts/ftn87.otf"
	ZO_TOOLTIP_STYLES["cadwellObjectiveTitle"]["fontFace"] = "ESOIta/fonts/ftn87.otf"
	ZO_TOOLTIP_STYLES["lootTooltip"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_TOOLTIP_STYLES["socialTitle"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_TOOLTIP_STYLES["collectionsInfoSection"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_TOOLTIP_STYLES["instantUnlockIneligibilitySection"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_TOOLTIP_STYLES["voiceChatBodyHeader"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_TOOLTIP_STYLES["groupDescription"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_TOOLTIP_STYLES["attributeTitleSection"]["fontFace"] = "ESOIta/fonts/ftn87.otf"
	ZO_TOOLTIP_STYLES["itemComparisonStatValuePairValue"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["tooltip"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["bodySection"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["bodyHeader"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["itemTagsSection"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["bagCountSection"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["stableGamepadTooltip"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["abilityUpgradeSection"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["worldMapTooltip"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["mapTitle"]["fontFace"] = "ESOIta/fonts/ftn87.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["mapQuestTitle"]["fontFace"] = "ESOIta/fonts/ftn87.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["mapLocationTooltipContentHeader"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["mapLocationTooltipWayshrineHeader"]["fontFace"] = "ESOIta/fonts/ftn87.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["mapKeepUnderAttack"]["fontFace"] = "ESOIta/fonts/ftn87.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["cadwellObjectiveTitle"]["fontFace"] = "ESOIta/fonts/ftn87.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["lootTooltip"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["socialTitle"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["collectionsInfoSection"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["instantUnlockIneligibilitySection"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["voiceChatBodyHeader"]["fontFace"] = "ESOIta/fonts/ftn57.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["groupDescription"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["attributeTitleSection"]["fontFace"] = "ESOIta/fonts/ftn87.otf"
	ZO_CRAFTING_TOOLTIP_STYLES["itemComparisonStatValuePairValue"]["fontFace"] = "ESOIta/fonts/ftn47.otf"
	
	SetSCTKeyboardFont("ESOIta/fonts/univers67.ttf|29|soft-shadow-thick")
	SetSCTGamepadFont("ESOIta/fonts/ftn87.otf|35|soft-shadow-thick")
	
	ZO_MapLocationTooltipHeader:SetText(zo_strformat("<<C:1>>", ZO_MapLocationTooltipHeader:GetText()))
	
	if LibStub then
		local LMP = LibStub("LibMediaProvider-1.0", true)
		if LMP then
			LMP.MediaTable.font["Univers 67"] = nil 
			LMP.MediaTable.font["Univers 57"] = nil
			LMP.MediaTable.font["Skyrim Handwritten"] = nil
			LMP.MediaTable.font["ProseAntique"] = nil
			LMP.MediaTable.font["Trajan Pro"] = nil
			LMP.MediaTable.font["Futura Condensed"] = nil
			LMP.MediaTable.font["Futura Condensed Bold"] = nil
			LMP.MediaTable.font["Futura Condensed Light"] = nil
			LMP:Register("font", "Univers 67", "ESOIta/fonts/univers67.ttf")
			LMP:Register("font", "Univers 57", "ESOIta/fonts/univers57.ttf")
			LMP:Register("font", "Skyrim Handwritten", "ESOIta/fonts/handwritten_bold.ttf")
			LMP:Register("font", "ProseAntique", "ESOIta/fonts/antquab.ttf")
			LMP:Register("font", "Trajan Pro", "ESOIta/fonts/trajanpro-regular.ttf")
			LMP:Register("font", "Futura Condensed", "ESOIta/fonts/ftn57.otf")
			LMP:Register("font", "Futura Condensed Bold", "ESOIta/fonts/ftn87.otf")
			LMP:Register("font", "Futura Condensed Light", "ESOIta/fonts/ftn47.otf")
			LMP:SetDefault("font", "Univers 57")
		end
	end
	
	if LWF3 then
		LWF3.data.Fonts = {
			["Arial Narrow"] = "ESOIta/fonts/univers57.ttf",
			["Consolas"] = "ESOIta/fonts/univers57.ttf",
			["ESO Cartographer"] = "ESOIta/fonts/univers57.ttf",
			["Fontin Bold"] = "ESOIta/fonts/univers57.ttf",
			["Fontin Italic"] = "ESOIta/fonts/univers57.ttf",
			["Fontin Regular"] = "ESOIta/fonts/univers57.ttf",
			["Fontin SmallCaps"] = "ESOIta/fonts/univers57.ttf",
			["Futura Condensed"]= "ESOIta/fonts/univers57.ttf",
			["Futura Light"] = "ESOIta/fonts/ftn47.otf",
			["ProseAntique"] = "ESOIta/fonts/antquab.ttf",
			["Skyrim Handwritten"]= "ESOIta/fonts/handwritten_bold.ttf",
			["Trajan Pro"] = "ESOIta/fonts/trajanpro-regular.ttf",
			["Univers 55"] = "ESOIta/fonts/univers57.ttf",
			["Univers 57"] = "ESOIta/fonts/univers57.ttf",
			["Univers 67"] = "ESOIta/fonts/univers67.ttf",
		}
	end
	
	if LWF4 then
		LWF4.data.Fonts = {
			["Arial Narrow"] = "ESOIta/fonts/univers57.ttf",
			["Consolas"] = "ESOIta/fonts/univers57.ttf",
			["ESO Cartographer"] = "ESOIta/fonts/univers57.ttf",
			["Fontin Bold"] = "ESOIta/fonts/univers67.ttf",
			["Fontin Italic"] = "ESOIta/fonts/univers57.ttf",
			["Fontin Regular"] = "ESOIta/fonts/univers57.ttf",
			["Fontin SmallCaps"] = "ESOIta/fonts/univers57.ttf",
			["Futura Condensed"]= "ESOIta/fonts/ftn57.otf",
			["Futura Light"] = "ESOIta/fonts/ftn47.otf",
			["ProseAntique"] = "ESOIta/fonts/antquab.ttf",
			["Skyrim Handwritten"]= "ESOIta/fonts/handwritten_bold.ttf",
			["Trajan Pro"] = "ESOIta/fonts/trajanpro-regular.ttf",
			["Univers 55"] = "ESOIta/fonts/univers57.ttf",
			["Univers 57"] = "ESOIta/fonts/univers57.ttf",
			["Univers 67"] = "ESOIta/fonts/univers67.ttf",
		}
	end
	
	function ZO_TooltipStyledObject:GetFontString(...)
		local fontFace = self:GetProperty("fontFace", ...)
		local fontSize = self:GetProperty("fontSize", ...)
		local fontStyle = self:GetProperty("fontStyle", ...)
		
		if fontFace == "$(GAMEPAD_LIGHT_FONT)" then
			fontFace = "ESOIta/fonts/ftn47.otf"
		end
		if fontFace == "$(GAMEPAD_MEDIUM_FONT)" then
			fontFace = "ESOIta/fonts/ftn57.otf"
		end
		if fontFace == "$(GAMEPAD_BOLD_FONT)" then
			fontFace = "ESOIta/fonts/ftn87.otf"
		end
		
		if(fontFace and fontSize) then
			if type(fontSize) == "number" then
				fontSize = tostring(fontSize)
			end
			if(fontStyle) then
				return string.format("%s|%s|%s", fontFace, fontSize, fontStyle)
			else
				return string.format("%s|%s", fontFace, fontSize)
			end
		else
			return "ZoFontGame"
		end
	end
end